var utils = {
  transTimeFormat : function(second){
    if (!second) return '00:00';
    var m = Math.floor(second/60) < 10
            ? '0' + Math.floor(second/60)
            : Math.floor(second/60)
    var s = '00' + Math.floor(second%60);
    s = s.substring(s.length - 2);
    return m + ':' + s;
  }
}
function Audio(config){
  this.selector = config.selector;
  this.src = config.src;
  this.isFirstTimeInTimeupdate = true;
}

// data-clicks:1为第一次点击，2暂停，3播放
Audio.prototype = {
  init : function(){
    var thix = this;
    thix.play();
    thix.onUpdate();
    thix.onEnd();//ios不支持
  },
  isReady : function(){
    // 标识下现在正在准备数据，以避免多次点击
    var thix = this;
    if(thix.selector.attr('isAudioReady') == 'yes'){
      return true
    }else{
      return false
    }
  },
  play : function(){
    var thix = this;
    if(!thix.isReady()){
      thix.selector.addClass('icon-loading')
    }

    ydk.playVoice({
      currentTime : thix.selector.data('ctime'),
      localId : thix.src,
      success : function(res){
        thix.selector.removeClass('icon-playing icon-loading').addClass('icon-stop');

        thix.selector.data('clicks' , 2);
      }
    });
  },
  pause : function(){
    var thix = this;
    ydk.pauseVoice({
      // pause ，play 从头开始播放了
      localId : thix.src,
      success : function(res){
          if(thix.isReady()){
            thix.selector.data('clicks' , 3);
          }else{
            thix.selector.data('clicks' , 1);
          }
          thix.selector.removeClass('icon-stop icon-loading').addClass('icon-playing');
      }
    });
  },
  pauseOrther : function(item){
    ydk.pauseVoice({
      localId : item.attr('src'),
      success : function(res){
          item.data('clicks' , 3);
          item.removeClass('icon-stop icon-loading').addClass('icon-playing');
      }
    });
  },
  onUpdate : function(){
    var thix = this;
    ydk.onVoicePlayProgress({
        localId : thix.src,
        success : function(res){
          var ctime = res.currentTime;
          var dtime = res.duration;
          if (!ctime) return;
          thix.selector.data('ctime' , ctime)
          if (thix.isFirstTimeInTimeupdate) {
              thix.isFirstTimeInTimeupdate = false;
              thix.selector.attr('isAudioReady', 'yes');
          }
          thix.updateShowTime(utils.transTimeFormat(ctime), utils.transTimeFormat(dtime));

          var spre = thix.updateProgress(ctime, dtime);
          // 播放完
          if (spre === 100) {
              thix.updateShowTime(utils.transTimeFormat(thix.selector.data('length')));
              thix.selector.removeClass('icon-stop icon-loading').addClass('icon-playing');
              // 重置计数，使得下次点击时为播放状态
              thix.selector.data('clicks', 3);
              thix.selector.data('ctime', 0);
          }
          }
      })
  },
  onEnd : function(){
    var thix = this;
    ydk.onVoicePlayEnd({
        localId : thix.src,
        success : function(res){
            thix.updateShowTime(utils.transTimeFormat(thix.selector.data('length')));
            thix.selector.removeClass('icon-stop icon-loading').addClass('icon-playing');
            // 重置计数，使得下次点击时为播放状态
            thix.selector.data('clicks', 3);
            thix.selector.data('ctime', 0);
        }
    });
  },
  updateShowTime : function(time){
    var thix = this;

    if (thix.selector.find('span.time').length === 0) {
          thix.selector.append('<span class="time"></span>');
      }
      thix.selector.find('span.time').html(time);
  },
  updateProgress : function(a , b){
    var thix = this;

    if (thix.selector.find('div.progress').length === 0) {
          thix.selector.append('<div class="progress"><div class="red"></div>'
            +'<a class="circle" href="javascript:;"></a></div>');
      }
      var p = a / b * 100;
      p = p > 99.99 ? 100 : p;

      thix.selector.find('div.progress .red').width(p + '%');
      thix.selector.find('div.progress .circle').css({'left' : p + '%'});

      if (p === 100) {
      }

      return p;
  }
}

  var audioPlaySelector = 'div.audio-play-strip';

  function audioStrip(selector){
    var src = selector.attr('src'),
        _audio = new Audio({
          selector : selector,
          src : src
        });

    var $audioPlayBtn = selector.find('a.icon'),
        $audioPlayCircle = selector.find('a.circle'),
        $audioPlayProgress = selector.find('div.progress'),
        audioGrayWidth = selector.find('div.gray').width(),
        $delBtn = selector.find('i.del');

    $delBtn.click(function(){
      selector.remove();
      RE.deleteItem();
      RE.placeCaretAtEndEditor();
    })

    selector.find('span.time').html(utils.transTimeFormat(selector.data('length')))

    var hasTouch= "ontouchstart" in window,
        start_ev = hasTouch ? "touchstart" : "mousedown",
        move_ev = hasTouch ? "touchmove" : "mousemove",
        end_ev = hasTouch ? "touchend" : "mouseup";

    var startX = $audioPlayProgress.offset().left,
        currentTime = 0;

    // 点击播放/暂停按钮后的处理逻辑
    $audioPlayBtn.on('click' , function(e){

      var playItem = $(audioPlaySelector+'.icon-stop'),
          clickCounts = selector.data('clicks');
      // data-clicks:1为第一次点击，2暂停，3播放
      if(clickCounts == 1){
        if(playItem.length > 0){
          // 关闭其他在播放中是音频
          _audio.pauseOrther(playItem)
        }
        _audio.init();
      }else if(_audio.isReady() && clickCounts == 2){
        _audio.pause();
      }else if(_audio.isReady() && clickCounts == 3){
        if(playItem.length > 0){
          // 关闭其他在播放中是音频
          _audio.pauseOrther(playItem)
        }
        _audio.play();
      }else{
        console.log('audio no ready')
        return
      }

    })


    // 点击进度条上的圆圈
    $audioPlayCircle.on(start_ev , function(e){
      e.preventDefault();
      var playItem = $(audioPlaySelector+'.icon-stop');
      if(playItem.length > 0){
        // 关闭其他在播放中是音频
        _audio.pauseOrther(playItem)
      }

      $audioPlayCircle.data('status','1')
      _audio.pause()

      if(selector.data('clicks') == 1){
        _audio.onUpdate();
      }
    })
    $audioPlayCircle.on(end_ev , function(e){
      $audioPlayCircle.data('status','0')
      setTimeout(function(){
        _audio.play()
      },500)
      console.log('拖动完成 ctime：'+selector.data('ctime'))
    })
    $audioPlayProgress.mouseleave(function(e){
      $audioPlayCircle.data('status','0')
      // console.log('拖动完成 ctime：'+selector.data('ctime'))
    });

    $audioPlayProgress.on(move_ev , function(e){
      e.preventDefault();
      var moveX = 0;
      if(hasTouch){
        moveX = e.touches[0].pageX - startX;
      }
      else{
        moveX = e.pageX- startX;
      }
      var per = moveX/audioGrayWidth ;
      currentTime = parseInt(selector.data('length')) * per;
      if(per > 0 && per < 1 && $audioPlayCircle.data('status') == 1){
        $audioPlayProgress.find('.red').width(per*100 + '%');
        $audioPlayProgress.find('.circle').css({'left' : per*100 + '%'});
        selector.data('ctime' , currentTime)

        selector.find('span.time').html(utils.transTimeFormat(currentTime))
      }
    })
  }
